# gdx-tests compatibility

- Accelerometer: Not yet implemented
- ActionSequence: Works
- Action: Works
- Affine2: Works
- Alpha: Works
- Animation3D: JSON deserialization error, stack corruption
- Animation: Works
- Anisotropy: Works
- Annotation: Annotations not yet implemented
- AssetManager: Crashes on I18N stuff
- AtlasIssue: Works
- AudioDevice: Not yet implemented
- AudioRecorder: Not yet implemented
- Basic3DScene: Works
- Basic3D: Works
- Benchmark3D: Occasional errors with deserialization
- BigMesh: Works
- BitmapFontAlignment: Works
- BitmapFontAtlasRegion: Works
- BitmapFontDistanceField: Works
- BitmapFontFlip: Works
- BitmapFontMetrics: Works
- BitmapFont: Works
- Blit: Works
- Box2DCharacterController: Works
- Box2D: Works
- Box2DTestCollection: Works
- Bresenham2: Works
- BufferUtils: Works
- Collections: Map hashing doesn't work, needs method optimization fix
- Color: Works
- ComplexAction: Works
- Container: Works
- Coordinates: Works
- CpuSpriteBatch: Works
- Cull: Works
- CustomShaderSpriteBatch: Works
- Decal: Works
- DefaultTextureBinder: Works
- DelaunayTriangulator: Works
- DeltaTime: Works
- DisplayMode: Works
- Download: Not yet implemented
- Dpi: Works
- DragAndDrop: Works
- ETC1: "Couldn't load pkm file"
- EdgeDetection: Works
- Exit: Doesn't work
- ExternalMusic: Works
- Files: Fails due to Classpath workaround
- FilterPerformance: Works
- FloatTexture: GL30 not yet implemented
- Fog: Works
- FrameBufferCubemap: Works
- FrameBuffer: Works
- FramebufferToTexture: Works
- FreeTypeAtlas: Font has incorrect background
- FreeTypeDispose: Heap usage not yet implemented
- FreeTypeFontLoader: Font has incorrect background
- FreeTypeIncremental: Font has incorrect background
- FreeTypeMetrics: Font has incorrect background
- FreeType: Font has incorrect background
- FreeTypePack: Font has incorrect background
- GLES30: Works
- GLProfilerError: Can't test without keyboard support
- GWTLossyPremultipliedAlpha: Works
- GestureDetector: Flinging values are way too high
- GroupCuling: Works
- GroupFade: Works
- Group: Works
- GwtInput: Works
- HeightMap: Works
- HelloTriangle: Works
- HexagonalTiledMap: Works
- I18NMessage: Doesn't work
- I18NSimpleMessage: Mostly works, Date formatting not implemented yet
- ImageScale: Works
- Image: Works
- IndexBufferObjectShader: Works
- InstancedRendering: GL30 not yet supported
- IntegerBitmapFont: Works
- InternationalFonts: Font has blue background
- Interpolation: Works
- IntersectorOverlapConvexPolygons: Works
- InverseKinematics: Works
- IsometricTile: Works
- Issue: Works
- JniGen: Works
- Json: Works with occasional primitive array related GC crashes
- KTX: Crash
- LabelScale: Works
- Label: Works
- LifeCycle: Works
- Lights: Works
- MaterialEmissive: Works
- Material: Works
- MatrixJNI: Works
- MeshBuilder: Works
- MeshShader: Works
- MipMap2D: Works
- MipMap: Works
- ModelCache: Mostly works, causes intermittent crashes related to GC/serialization
- ModelLoader: Works
- Model: Works
- MoveSprite: Works
- MultipleRenderTarget: GL30 not yet implemented
- Multitouch: Works
- Music: Plays fine, but tracking/stopping doesn't work correctly
- NetAPI: GC related crash on GET Text
- NinePatch: Works
- OpenBrowser: Works
- Parallax: Works
- ParticleControllerInfluencerSingle: Works
- ParticleController: Works
- ParticleEmitterChangeSprite: Works
- ParticleEmitter: Works
- ParticleEmitters: Works
- Path: Works
- PingPongSocket: Not yet implemented
- PixelBufferObject: Threading issue
- PixelPerfect: Works
- PixelsPerInch: Works, but not accurate for Switch yet
- PixmapBlending: Works
- PixmapPackerIO: DeflaterOutputStream blocks indefinitely
- PixmapPacker: Works
- Pixmap: Works
- PNG: FileHandle parent crash
- PolarAcceleration: Works
- PolygonRegion: Works
- PolygonSprite: Works
- Preferences: Works
- ProgressiveJPEG: Works
- Project: Works
- ProjectiveTexture: Works
- QuadTreeFloatNearest: Works
- QuadTreeFloat: Works
- ReflectionCorrectness: Doesn't work
- Reflection: Doesn't work
- Rotation: Works
- RunnablePost: Works
- Scene2d: Works
- ScrollPane2: Works
- ScrollPaneScrollBars: Works
- ScrollPane: Works
- ScrollPaneTextArea: Works
- ScrollPaneWithDynamicScrolling: Works
- Select: Works
- Sensor: Orientation input not yet implemented
- ShaderCollection: Serialization crash/stack corruption
- ShaderMultitexture: Works
- Shader: Works
- ShadowMapping: Works
- ShapeRendererAlpha: Works
- ShapeRenderer: Works
- ShortSound: Works
- SimpleAnimation: Works
- SimpleDecal: Works
- SimpleStageCulling: Works
- SimpleVertexShader: Works
- Skeleton: Works
- SortedSprite: Works
- Sound: Basic functionality works, pitch not implemented, panning doesn't work, stop has delay
- SpriteBatchOriginScale: Works
- SpriteBatchRotation: Works
- SpriteBatchShader: Works
- SpriteCacheOffset: Works
- SpriteCache: Works
- StageDebug: Works
- StagePerformance: Works
- Stage: Works
- SuperKoalio: Works
- SwitchInput: Works
- SwitchSocket: Works
- TableLayout: Works
- Table: Works
- TangentialAcceleration: Works
- TextArea: Works
- TextArea2: Works
- TextArea3: Works
- TextButton: Works
- TextInputDialog: Works
- TextureArray: GL30 not yet implemented
- TextureAtlas: Works
- TextureData: Works
- TextureDownload: Networking not yet implemented
- TextureRegion3D: Works
- Thread: Bug with try-catch/synchronized block nesting
- TideMapAssetManager: Works
- TideMapDirectLoader: Works
- Tile: Works
- TileMapAnimationLoading: Works
- TiledMapAssetManager: Doesn't work
- TiledMapAtlasAssetManager: Doesn't work
- TiledMapBench: Works
- TiledMapDirectLoader: Works
- TiledMapGroupLayer: Works
- TiledMapLayerOffset: Doesn't work
- TiledMapModifiedExternalTileset: Works
- TiledMapObjectLoading: Works
- TimeUtils: Works
- Touchpad: Works
- TreeTest: Works
- UBJsonTest: Crash on GC
- UI: Works
- UtfFont: Works
- VBOWithVAOPerformance: GL30 not yet implemented
- Vector2d: Works
- VertexBufferObjectShader: Works
- Vibrator: Not yet implemented
- ViewportTest1: Works (Can't switch viewports without space bar)
- ViewportTest2: Works (Can't switch viewports without space bar)
- ViewportTest3: Works (Can't switch viewports without space bar)
- Voxel: Works, but long load time due to buffer implementation
- YDownTest: Works
